﻿using AutoMapper;
using Confluent.Kafka;
using System.Data;
using Ys.Scada.Backend.Models;
using Ys.Scada.Core;
using Ys.Scada.Repository;
using Ys.Scada.Repository.Domain;

namespace Ys.Scada.Backend
{
    public class MapperProfile : Profile
    {
        public MapperProfile()
        {
            AllowNullDestinationValues = true;
            CreateMap(typeof(PagedData<>), typeof(PagedData<>));
            CreateMap<User, UserModel > ()
                .ForMember(dest => dest.Password, opt => opt.Ignore())
                .ReverseMap();
            CreateMap<Permission, PermissionModel>()
                .ReverseMap();
            CreateMap<UserRole, RoleModel>()
                .ReverseMap();
            CreateMap<UserRole, RoleModel>()
                .ReverseMap();
            CreateMap<Resources, ResourcesModel>()
                .ReverseMap();
            CreateMap<Resources, ResourcesReleaseModel>()
                .ReverseMap();
            CreateMap<Document, DocumentModel>()
                .ReverseMap();
            CreateMap<Document, DocumentReleaseModel>()
                .ReverseMap();
            CreateMap<DataSource, DataSourceModel>()
                .ReverseMap();
            CreateMap<Release, ReleaseModel>()
                .ReverseMap();
            CreateMap<User, UserExtensModel>()
                .ReverseMap();
            CreateMap<Document, Release>()
                .ReverseMap();
            CreateMap<Variable, VariableModel>()
                .ReverseMap();
            
        }
    }
}
