﻿using System.ComponentModel.DataAnnotations;

namespace Ys.Scada.Backend.Models
{
    public class UserModel
    {
        public int Id { get; set; }
        public string Name { get; set; }
        [Required(ErrorMessage = "用户名必填")]
        public string UserName { get; set; }
        public DateTime LastLoginTime { get; set; }
        public int Status { get; set; }
        public bool IsSystemRole { get; set; }
        public string Phone { get; set; }
        [Required(ErrorMessage = "密码必填")]
        public string Password { get; set; }
    }
    public class UserExtensModel : UserModel
    {
        public List<RoleModel> Roles { get; set; } = new List<RoleModel>();
        public List<PermissionModel> Permissions { get; set; } = new List<PermissionModel>();
    }
}
