﻿
using Microsoft.IdentityModel.Tokens;
using NetCoreServer;
using System.Collections.Concurrent;
using System.IdentityModel.Tokens.Jwt;
using System.Linq;
using System.Net;
using System.Net.Sockets;
using System.Text;
using Ys.Scada.Core.Common;
using Ys.Scada.Core.EventModels;
using Ys.Scada.Core.MQ;
using Ys.Scada.Repository;
using Ys.Scada.Repository.Domain;

namespace Ys.Scada.Backend.WS
{

    public class DataServer : WsServer
    {
        private int count = 0;
        private readonly ConcurrentDictionary<string, DataSession> _clients;
        private readonly string _secretKey;
        private static object obj_lock = new object();
        public DataServer(IPAddress address, int port, string secretKey) : base(address, port) 
        {
            _clients = new ConcurrentDictionary<string, DataSession>();
            _secretKey = secretKey;
        }
        public  Task MyMulticast(TagDataEventModel tag)
        {
            foreach (var client in _clients.Values)
            {
                if (client.IsConnected)
                {
                    var ukey = Global.GetUserKey(client.userId.ToString());
                    var codes = ForgeCache.Instance.GetValue<string>(ukey);
                    if (codes.Contains(tag.Id))
                        client.SendData(tag);
                }
                else
                    RemoveClient(client.Id.ToString());
            }
            return Task.CompletedTask;
        }
        protected override TcpSession CreateSession() 
        {
            var client = new DataSession(this, _secretKey);
            AddClient(client.Id.ToString(), client);
            return client; 
        }
        protected override void OnError(SocketError error)
        {
            Console.WriteLine($"Chat WebSocket server caught an error with code {error}");
        }
        public void AddClient(string key, DataSession value) 
        {
            _clients.TryAdd(key, value);
        }
        public void RemoveClient(string key)
        {
            _clients.TryRemove(key, out DataSession value);
        }
    }
}
