﻿using Microsoft.AspNetCore.Hosting.Server;
using Microsoft.IdentityModel.Tokens;
using NetCoreServer;
using System.IdentityModel.Tokens.Jwt;
using System.Net.Sockets;
using System.Security.Claims;
using System.Security.Policy;
using System.Text;
using System.Text.RegularExpressions;
using System.Web;
using Ys.Scada.Core.EventModels;

namespace Ys.Scada.Backend.WS
{
    public class DataSession : WsSession
    {
        private readonly DataServer _dataServer;
        private readonly string _secretKey;
        public int userId;
        Timer _timer;
        private Dictionary<string, string> _data = new Dictionary<string, string>();
        public DataSession(WsServer server, string secretKey) : base(server)
        {
            _dataServer = (DataServer)server;
            _secretKey = secretKey;
        }
        public void tt(object obj)
        {
            SendText(new Random().Next(1000, 100000).ToString());
        }
        public string ParseAndValidateJwtToken(string token)
        {
            var securityKey = new SymmetricSecurityKey(Encoding.UTF8.GetBytes(_secretKey));
            var tokenHandler = new JwtSecurityTokenHandler();
            try
            {
                tokenHandler.ValidateToken(token, new TokenValidationParameters
                {
                    ValidateIssuerSigningKey = true,
                    IssuerSigningKey = securityKey,
                    ValidateIssuer = false,
                    ValidateAudience = false,
                    ValidateLifetime = true,
                    RequireExpirationTime = false,
                    ClockSkew = TimeSpan.FromSeconds(5)
                }, out SecurityToken validatedToken);
                JwtSecurityToken jwtToken = (JwtSecurityToken)validatedToken;
                return jwtToken?.Claims.Where(o => o.Type == ClaimTypes.NameIdentifier).FirstOrDefault()?.Value;
            }
            catch (SecurityTokenException e)
            {
            }
            catch (Exception e)
            {
            }
            return string.Empty;
        }
        public override void OnWsConnected(NetCoreServer.HttpRequest request)
        {
            var match = Regex.Match(request.Url, "token=(?'token'.*)");
            if (!match.Success)
            {
                this.Disconnect();
                //OnWsDisconnected();
            }
            var token = match.Groups["token"].Value;
            if (string.IsNullOrWhiteSpace(token))
                this.Disconnect();
            var id = ParseAndValidateJwtToken(token);
            if (string.IsNullOrEmpty(id)) 
                this.Disconnect();
            if (int.TryParse(id, out int uid))
                userId = uid;
            else
                this.Disconnect();
        }
        public override void OnWsDisconnected()
        {
            _dataServer.RemoveClient(Id.ToString());
            userId = int.MinValue;
        }
        public override void OnWsReceived(byte[] buffer, long offset, long size)
        {
            string message = Encoding.UTF8.GetString(buffer, (int)offset, (int)size);
            // Multicast message to all connected sessions
            //((WsServer)Server).MulticastText(message);
            SendTextAsync(message);
        }
        public void SendData(TagDataEventModel tagData) 
        {
                SendTextAsync(tagData.ToString());
        }
        protected override void OnError(SocketError error)
        {
            //Console.WriteLine($"Chat WebSocket session caught an error with code {error}");
        }
    }
}
