﻿using System.Threading.Channels;

namespace Ys.Scada.Core
{
    public interface IProducer<T>
    {
        Task PublishAsync(T msg, CancellationToken cancellationToken = default);
    }
    public class Producer<T> : IProducer<T>
    {
        private readonly ChannelWriter<T> _writer;
        public Producer(ChannelWriter<T> writer)
        {
            _writer = writer;
        }
        public Task PublishAsync(T msg, CancellationToken cancellationToken = default)
        {
            _writer.WriteAsync(msg, cancellationToken);
            return Task.CompletedTask;
        }
    }
}
