﻿using Microsoft.Extensions.DependencyInjection;
using Ys.Scada.Core.EventBus.Consumer;

namespace Ys.Scada.Core.EventBus.Subscriber
{
    /// <summary>
    /// 订阅者
    /// </summary>
    public class Subscriber : ISubscriber
    {
        private readonly IServiceProvider _serviceProvider;
        public Subscriber(IServiceProvider serviceProvider)
        {
            _serviceProvider = serviceProvider;
        }
        /// <summary>
        /// 获取所有订阅者
        /// </summary>
        /// <typeparam name="T">订阅者实体</typeparam>
        /// <returns></returns>
        public IList<IConsumer<T>> GetSubscriptions<T>()
        {
            using var scope = _serviceProvider.CreateScope();
            return scope.ServiceProvider.GetServices<IConsumer<T>>()?.ToList();
        }
    }
}
