﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using System.Threading.Tasks;

namespace Ys.Scada.Core.MQ
{
    [StructLayout(LayoutKind.Auto)]
    public readonly struct TransportMessage
    {
        public TransportMessage(IDictionary<string, string?> headers, ReadOnlyMemory<byte> body)
        {
            Headers = headers ?? throw new ArgumentNullException(nameof(headers));
            Body = body;
        }
        public IDictionary<string, string?> Headers { get; }
        public ReadOnlyMemory<byte> Body { get; }
        public string GetId()
        {
            return Headers[MQ.Headers.MessageId]!;
        }
    }
}
