﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Ys.Scada.Core
{
    [Serializable]
    public class PagedData<T>
    {
        public PagedData() { List = new List<T>(); }
        public PagedData(IEnumerable<T> source, int pageIndex, int pageSize, int totalCount)
        {
            PageSize = pageSize;
            PageIndex = pageIndex;
            Total = totalCount;
            List = source;
        }
        public PagedData(IEnumerable<T> source, int pageIndex, int pageSize)
        {
            PageSize = pageSize;
            PageIndex = pageIndex;
            Total = source.Count();
            List = source;
        }
        public IEnumerable<T> List { get; }
        public int PageIndex { get; set; }
        public int PageSize { get; set; }
        public int Total { get; set; }
    }
}
