﻿using Confluent.Kafka;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Ys.Scada.Kafka
{
    public class KafkaOptions
    {
        public readonly Dictionary<string, string> MainConfig;
        public KafkaOptions()
        {
            MainConfig = new Dictionary<string, string>();
            RetriableErrorCodes = new List<ErrorCode>
            {
                ErrorCode.GroupLoadInProgress
            };
        }
        public string Servers { get; set; } = default!;
        public IList<ErrorCode> RetriableErrorCodes { get; set; }
        public KafkaTopicOptions TopicOptions { get; set; } = new();
    }
    public class KafkaTopicOptions
    {
        public short NumPartitions { get; set; } = -1;
        public short ReplicationFactor { get; set; } = -1;
    }
}
