﻿using RabbitMQ.Client.Events;
using RabbitMQ.Client;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Ys.Scada.RabbitMQ
{
    public class RabbitMQOptions
    {
        public  string ExchangeType = "topic";
        public string HostName { get; set; } = "localhost";
        public string Password { get; set; } 
        public string UserName { get; set; }
        public string ExchangeName { get; set; }
        public string QueueName { get; set; }
        public string Topic { get; set; }
        public int Port { get; set; } = -1;
        public QueueArgumentsOptions QueueArguments { get; set; } = null;
        public Action<ConnectionFactory>? ConnectionFactoryOptions { get; set; } = null;
        public BasicQos? BasicQosOptions { get; set; } = new BasicQos(100);
        public class QueueArgumentsOptions
        {
            public string QueueMode { get; set; } = default!;
            public int MessageTTL { get; set; } = 864000000;
            public string QueueType { get; set; } = default!;
        }
        public class BasicQos
        {
            public BasicQos(ushort prefetchCount, bool global = false)
            {
                PrefetchCount = prefetchCount;
                Global = global;
            }
            public ushort PrefetchCount { get; }
            public bool Global { get; }
        }
    }
}
