﻿using FreeSql.DataAnnotations;
using Newtonsoft.Json;

namespace Ys.Scada.Repository
{
    [JsonObject(MemberSerialization.OptIn), Table(Name = "user", DisableSyncStructure = false)]
    public class User : BaseEntity
    {
        public string Username { get; set; }
        public string Password { get; set; }
        public int Jti { get; set; }
        public string Phone { get; set; }
        public int Status { get; set; }
        public bool Active { get; set; }
        public bool IsSystemRole { get; set; }
        public string Name { get; set; }
        public DateTime LastLoginTime { get; set; }

        [Navigate(nameof(UserRoleMapping.UserId))]
        public virtual List<UserRoleMapping> Mapping { get; set; }
    }
}
